# Unleash

[Unleash](https://github.com/Unleash/unleash) is feature flipping solution. It allows us to activate or restrain fonctionalities acording a configuration.

## Usage

### 1. Create a rule

We use a functor to enforce several parameters :

| Params      |                     value                      |
| ----------- | :--------------------------------------------: |
| parameters  |                  'parameters                   |
| input       |                     'input                     |
| output      |                    'output                     |
| envUrl      |                     string                     |
| featureName |                     string                     |
| exec        | ('input, Unleash.config(parameters)) => output |

```rescript
module OutdatedApplicationConfig = {
  @spice
  type parameters = {version: string}
  type input = unit
  type output = bool
  let envUrl = Env.unleashUrl
  let featureName = "minimum-supported-version"

  let exec = (_, config: Unleash.config<parameters>) => {
    let appVersion =
      ReactNativeVersionNumber.appVersion->Js.Nullable.toOption->Option.getWithDefault("")

    config.strategies
    ->Array.get(0)
    ->Option.mapWithDefault(false, strategy =>
      config.enabled ? Semver.lt(appVersion, strategy.parameters.version) : false
    )
  }
}

module OutdatedApplication = Toolkit.Unleash.MakeFeature(OutdatedApplicationConfig)
```

### 2. Use the rule

```rescript
OutdatedApplication.exec()
->Promise.tapOk(outdated => {
  if (outdated) {
    Js.log("app outdated");
  }
})
```
